xref: /haiku/configure (revision 84edb1a177c32dd651ecf3234559d492a867edb4)
152a38012Sejakowatz#!/bin/sh
252a38012Sejakowatz#
3338b8dc3SIngo Weinhold# configure [ <options> ]
4614026d7Sshatty
5022fa244SIngo Weinhold# usage
6022fa244SIngo Weinhold#
7022fa244SIngo Weinhold# Prints usage.
8022fa244SIngo Weinhold#
9022fa244SIngo Weinholdusage()
10022fa244SIngo Weinhold{
11022fa244SIngo Weinhold	cat << EOF
12022fa244SIngo Weinhold
13022fa244SIngo WeinholdUsage: $0 <options>
14022fa244SIngo Weinholdoptions:
15e173a1ecSIngo Weinhold  --bootstrap <haikuporter> <HaikuPorts cross repo> <HaikuPorts repo>
16e173a1ecSIngo Weinhold                              Prepare for a bootstrap build. No pre-built
17e173a1ecSIngo Weinhold                              packages will be used, instead they will be built
18e173a1ecSIngo Weinhold                              from the sources (in several phases).
19e173a1ecSIngo Weinhold                              <haikuporter> is the path to the haikuporter tool
20e173a1ecSIngo Weinhold                              suitable for the host platform.
21e173a1ecSIngo Weinhold                              <HaikuPorts cross repo> is the path to a checked
22e173a1ecSIngo Weinhold                              out HaikuPorts cross-compilation repository.
23e173a1ecSIngo Weinhold                              <HaikuPorts repo> is the path to a checked out
24e173a1ecSIngo Weinhold                              HaikuPorts repository.
25c0e8cc1aSIngo Weinhold  --build-cross-tools <arch> [ <build tools dir> ]
26338b8dc3SIngo Weinhold                              Assume cross compilation. <build tools dir>
27338b8dc3SIngo Weinhold                              defines the location of the build tools sources.
28338b8dc3SIngo Weinhold                              They will be compiled and placed in the output
29a5b60fa8SOliver Tappe                              directory under "cross-tools". The HAIKU_* tools
30a5b60fa8SOliver Tappe                              variables will be set accordingly.
3120ab75e6SIngo Weinhold                              <arch> specifies the target architecture, either
321b38c341SAlexander von Gluck IV                              "x86_gcc2", "x86", "x86_64", "ppc", "m68k", "arm"
33c0e8cc1aSIngo Weinhold                              This option and --cross-tools-prefix can be
34c0e8cc1aSIngo Weinhold                              specified multiple times. The first cross tools
35c0e8cc1aSIngo Weinhold                              specify the primary tools, the subsequent ones the
36c0e8cc1aSIngo Weinhold                              secondary tools (for "hybrid" images).
37c0e8cc1aSIngo Weinhold                              For the first --build-cross-tools the
38c0e8cc1aSIngo Weinhold                              <build tools dir> argument must be specified and
39c0e8cc1aSIngo Weinhold                              for the subsequent ones it must be omitted.
40eccc7665SIngo Weinhold  --cross-tools-prefix <prefix>
41eccc7665SIngo Weinhold                              Assume cross compilation. <prefix> should be a
42eccc7665SIngo Weinhold                              path to the directory where the cross
43eccc7665SIngo Weinhold                              compilation tools are located, plus the platform
440da9c208SIngo Weinhold                              prefix, e.g. "/path/to/tools/i586-pc-haiku-".
45eccc7665SIngo Weinhold                              This overrides the HAIKU_* tool variables.
46a66c32ddSIngo Weinhold  --distro-compatibility <level>
47a66c32ddSIngo Weinhold                              The distribution's level of compatibility with
48a66c32ddSIngo Weinhold                              the official Haiku distribution. The generated
49a66c32ddSIngo Weinhold                              files will contain the respective trademarks
50a66c32ddSIngo Weinhold                              accordingly.
51a66c32ddSIngo Weinhold                              official -- the official Haiku distribution.
52a66c32ddSIngo Weinhold                              compatible -- a Haiku Compatible (tm) distro.
53a66c32ddSIngo Weinhold                              default -- any other distro (default value).
5460d8d8fcSIngo Weinhold  --enable-multiuser          Enable experimental multiuser support.
55eccc7665SIngo Weinhold  --help                      Prints out this help.
562ebcd86dSIngo Weinhold  --host-only                 Configure for building tools for the build host
572ebcd86dSIngo Weinhold                              only. Haiku cannot be built when configured like
582ebcd86dSIngo Weinhold                              this.
59eccc7665SIngo Weinhold  --include-gpl-addons        Include GPL licensed add-ons.
6067838392SAxel Dörfler  --include-patented-code     Enable code that is known to implemented patented
6167838392SAxel Dörfler                              ideas and techniques. If this option is not
6267838392SAxel Dörfler                              specified, the resulting distribution may still
6367838392SAxel Dörfler                              implement patented ideas and techniques. This
6467838392SAxel Dörfler                              option only disables code that is currently known
6567838392SAxel Dörfler                              to be problematic.
6676fa0be3SIngo Weinhold  --include-sources           Includes the source code of projects that require
6776fa0be3SIngo Weinhold                              either an offer of source code or a copy of the
6876fa0be3SIngo Weinhold                              patched sources. This is preferable when
6976fa0be3SIngo Weinhold                              distributing on physical mediums.
701974210fSFrançois Revol  --include-3rdparty          Include 3rdparty/ in the build system.
714880ae01SJessica Hamilton  -j<n>                       Only relevant for --build-cross-tools. Is passed
724880ae01SJessica Hamilton                              on to the make building the build tools.
73aa2e5ecaSOliver Tappe  --no-downloads              Do not download anything. Useful when trying to
74aa2e5ecaSOliver Tappe                              bootstrap and build Haiku from source only.
757c4641d0SOliver Tappe  --target=TARGET             Select build target platform.
767c4641d0SOliver Tappe                              [default=${TARGET_PLATFORM}]
77deb1a319SAlexander von Gluck IV                              valid targets=r5,bone,dano,haiku
78483b28e4SIngo Weinhold  --target-arch <arch>        Haiku only: Specify the target architecture to
79483b28e4SIngo Weinhold                              build for. Must be one of the architectures of the
80483b28e4SIngo Weinhold                              host system. The installed build tools for that
81483b28e4SIngo Weinhold                              architecture will be used.
82483b28e4SIngo Weinhold                              This option can be specified multiple times. The
83483b28e4SIngo Weinhold                              first occurrence specifies the primary
84483b28e4SIngo Weinhold                              architecture of the Haiku to build, subsequent
85483b28e4SIngo Weinhold                              ones the secondary architectures.
86961fc581SFrançois Revol  --update                    re-runs last configure invocation [must be given
877c4641d0SOliver Tappe                              as first option!]
88c2b76f7fSJonathan Schleifer  --use-clang                 Build with host Clang instead of GCC cross
89c2b76f7fSJonathan Schleifer                              compiler
90eccc7665SIngo Weinhold  --use-gcc-pipe              Build with GCC option -pipe. Speeds up the build
915a34a443SFrançois Revol                              process, but uses more memory.
92ed38d2efSJerome Duval  --use-gcc-graphite          Build with GCC Graphite engine for loop
93ed38d2efSJerome Duval                              optimizations. Only for gcc 4.
940385b065SIngo Weinhold  --use-32bit                 Use -m32 flag on 64bit host gcc compiler.
95bc96e8f3SIngo Weinhold  --use-xattr                 Use Linux xattr respectively *BSD extattr support
96bc96e8f3SIngo Weinhold                              for BeOS attribute emulation. Warning: Make sure
97bc96e8f3SIngo Weinhold                              your file system supports sufficient attribute
98bc96e8f3SIngo Weinhold                              sizes (4 KB per file for all attributes won't
99bc96e8f3SIngo Weinhold                              suffice).
100bc96e8f3SIngo Weinhold  --use-xattr-ref             Use the generic BeOS attribute emulation, but use
101bc96e8f3SIngo Weinhold                              Linux xattr respectively *BSD extattr support to
102bc96e8f3SIngo Weinhold                              make it more robust (i.e. attribute mix-ups become
103bc96e8f3SIngo Weinhold                              less likely).
1044da6cf84SFrançois Revol  --with-gdb <gdb sources dir>
1054da6cf84SFrançois Revol                              specify the path to a GDB source dir, to build
1064da6cf84SFrançois Revol                              GDB for each arch we build the cross-tools for.
107338b8dc3SIngo Weinhold
108338b8dc3SIngo Weinholdenvironment variables:
10963701e7dSOliver Tappe  CC                          The host compiler. Defaults to "gcc".
110c0e8cc1aSIngo Weinhold  HAIKU_AR_x86_gcc2           The static library archiver for x86_gcc2.
111c0e8cc1aSIngo Weinhold                              Defaults to "ar".
112c0e8cc1aSIngo Weinhold  HAIKU_CC_x86_gcc2           The x86_gcc2 compiler. Defaults to "gcc".
113c0e8cc1aSIngo Weinhold  HAIKU_LD_x86_gcc2           The x86_gcc2 linker. Defaults to "ld".
114c0e8cc1aSIngo Weinhold  HAIKU_OBJCOPY_x86_gcc2      The x86_gcc2 objcopy to be used. Defaults to
115c0e8cc1aSIngo Weinhold                              "objcopy".
116c0e8cc1aSIngo Weinhold  HAIKU_RANLIB_x86_gcc2       The static library indexer for x86_gcc2. Defaults
117c0e8cc1aSIngo Weinhold                              to "ranlib".
118c0e8cc1aSIngo Weinhold  HAIKU_STRIP_x86_gcc2        The x86_gcc2 strip command. Defaults to "strip".
119a04a520bSJonathan Schleifer  HAIKU_NASM                  The nasm assembler (x86 and x86_64 only).
120c0e8cc1aSIngo Weinhold  HAIKU_CPPFLAGS_<arch>       The preprocessor flags for target architecture
121c0e8cc1aSIngo Weinhold                              <arch>. Defaults to "".
122c0e8cc1aSIngo Weinhold  HAIKU_CCFLAGS_<arch>        The C flags for target architecture <arch>.
123c0e8cc1aSIngo Weinhold                              Defaults to "".
124c0e8cc1aSIngo Weinhold  HAIKU_CXXFLAGS_<arch>       The C++ flags for target architecture <arch>.
125c0e8cc1aSIngo Weinhold                              Defaults to "".
126c0e8cc1aSIngo Weinhold  HAIKU_LDFLAGS_<arch>        The linker flags for target architecture <arch>.
127c0e8cc1aSIngo Weinhold                              Defaults to "".
128c0e8cc1aSIngo Weinhold  HAIKU_ARFLAGS_<arch>        The flags passed to HAIKU_AR for target
129c0e8cc1aSIngo Weinhold                              architecture <arch> for archiving. Defaults to
130c0e8cc1aSIngo Weinhold                              "cru".
131c0e8cc1aSIngo Weinhold  HAIKU_UNARFLAGS_<arch>      The flags passed to HAIKU_AR for target
132c0e8cc1aSIngo Weinhold                              architecture <arch> for unarchiving. Defaults to
133c0e8cc1aSIngo Weinhold                              "x".
13464f6da31SIngo Weinhold
135c0e8cc1aSIngo WeinholdNon-default output directories:
13664f6da31SIngo Weinhold  By default all objects, build configuration, and other related files are
13764f6da31SIngo Weinhold  stored in /path/to/haiku_source/generated.  To store objects in a non-default
13864f6da31SIngo Weinhold  location, run "../../relative/path/to/haiku_source/configure <options>" from
13964f6da31SIngo Weinhold  within your non-default location.  "jam [ options ] targets" can then be run
14064f6da31SIngo Weinhold  directly inside your non-default location.  Another option is to invoke "jam
14164f6da31SIngo Weinhold  [ options ] targets" from within haiku_source.  This can be accomplished by
14264f6da31SIngo Weinhold  either "export HAIKU_OUTPUT_DIR=your non-default location" before invoking
14364f6da31SIngo Weinhold  jam or by creating a symlink of haiku_source/generated pointing to your
14464f6da31SIngo Weinhold  non-default location and running jam.
14564f6da31SIngo Weinhold
14664f6da31SIngo Weinhold
147022fa244SIngo WeinholdEOF
148022fa244SIngo Weinhold}
149022fa244SIngo Weinhold
150022fa244SIngo Weinhold# assertparam
151022fa244SIngo Weinhold#
152022fa244SIngo Weinhold# Checks whether at least one parameter is left.
153022fa244SIngo Weinhold#
154022fa244SIngo Weinholdassertparam()
155022fa244SIngo Weinhold{
15620ab75e6SIngo Weinhold	if [ $2 -lt 2 ]; then
157022fa244SIngo Weinhold		echo $0: \`$1\': Parameter expected.
158022fa244SIngo Weinhold		exit 1
159022fa244SIngo Weinhold	fi
160022fa244SIngo Weinhold}
161022fa244SIngo Weinhold
16220ab75e6SIngo Weinhold# assertparams
16320ab75e6SIngo Weinhold#
16420ab75e6SIngo Weinhold# Checks whether at least a certain number of parameters is left.
16520ab75e6SIngo Weinhold#
16620ab75e6SIngo Weinholdassertparams()
16720ab75e6SIngo Weinhold{
16820ab75e6SIngo Weinhold	if [ $3 -le $2 ]; then
16920ab75e6SIngo Weinhold		echo $0: \`$1\': Not enough parameters.
17020ab75e6SIngo Weinhold		exit 1
17120ab75e6SIngo Weinhold	fi
17220ab75e6SIngo Weinhold}
17320ab75e6SIngo Weinhold
174e173a1ecSIngo Weinhold# absolute_path
175e173a1ecSIngo Weinhold#
176e173a1ecSIngo Weinhold# returns the absolute path of a given path.
177e173a1ecSIngo Weinhold#
178e173a1ecSIngo Weinholdabsolute_path()
179e173a1ecSIngo Weinhold{
1806a4f3954SFrançois Revol	if [ "x$1" != "x${1#/}" ]; then
181e173a1ecSIngo Weinhold		echo "$1"
182e173a1ecSIngo Weinhold	else
183e173a1ecSIngo Weinhold		echo "`pwd`/$1"
184e173a1ecSIngo Weinhold	fi
185e173a1ecSIngo Weinhold}
186e173a1ecSIngo Weinhold
18739d444a3SArvind S Raj# check_dir_exists
18839d444a3SArvind S Raj#
18939d444a3SArvind S Raj# check if a directory exists or not
19039d444a3SArvind S Raj#
19139d444a3SArvind S Rajcheck_dir_exists()
19239d444a3SArvind S Raj{
19339d444a3SArvind S Raj	if [ -d "$1" ]; then
19439d444a3SArvind S Raj		return 0
19539d444a3SArvind S Raj	else
19639d444a3SArvind S Raj		return 1
19739d444a3SArvind S Raj	fi
19839d444a3SArvind S Raj}
19939d444a3SArvind S Raj
200502882dbSJessica Hamilton# check_file_exists
201502882dbSJessica Hamilton#
202502882dbSJessica Hamilton# check if a file exists or not
203502882dbSJessica Hamilton#
204502882dbSJessica Hamiltoncheck_file_exists()
205502882dbSJessica Hamilton{
206502882dbSJessica Hamilton	if [ -f "$1" ]; then
207502882dbSJessica Hamilton		return 0
208502882dbSJessica Hamilton	else
209502882dbSJessica Hamilton		return 1
210502882dbSJessica Hamilton	fi
211502882dbSJessica Hamilton}
212502882dbSJessica Hamilton
2139a001156SOliver Tappe# real_path
2149a001156SOliver Tappe#
2159a001156SOliver Tappe# returns the realpath of a symbolic link.
2169a001156SOliver Tappe#
2179a001156SOliver Tappereal_path()
2189a001156SOliver Tappe{
2199a001156SOliver Tappe	perl -MCwd=realpath -e'print realpath($ARGV[0]), "\n"' "$1"
2209a001156SOliver Tappe}
2219a001156SOliver Tappe
22209c5682dSIngo Weinhold# standard_gcc_settings
22309c5682dSIngo Weinhold#
22409c5682dSIngo Weinhold# Sets the variables for a GCC platform.
22509c5682dSIngo Weinhold#
22609c5682dSIngo Weinholdstandard_gcc_settings()
22709c5682dSIngo Weinhold{
228c0e8cc1aSIngo Weinhold	local gcc=$1
229c0e8cc1aSIngo Weinhold
230138f5fb4SIngo Weinhold	if which greadlink > /dev/null 2>&1; then
231b29b48b1SMatt Madia		readlink="greadlink -e"
232138f5fb4SIngo Weinhold	elif which realpath > /dev/null 2>&1; then
233b29b48b1SMatt Madia		readlink=realpath
2349a001156SOliver Tappe	elif readlink -e / > /dev/null 2>&1; then
235b29b48b1SMatt Madia		readlink="readlink -e"
2369a001156SOliver Tappe	else
2379a001156SOliver Tappe		readlink=real_path
238b4b6d83cSMatt Madia	fi
239138f5fb4SIngo Weinhold
24009c5682dSIngo Weinhold	# PLATFORM_LINKLIBS
241c0e8cc1aSIngo Weinhold	local gcclib=`$gcc -print-libgcc-file-name`
242c0e8cc1aSIngo Weinhold	local gccdir=`dirname ${gcclib}`
2435b0f7b1bSOliver Tappe
244c0e8cc1aSIngo Weinhold	local gccRawVersion=`$gcc -dumpversion`
245c0e8cc1aSIngo Weinhold	local gccMachine=`$gcc -dumpmachine`
246338b8dc3SIngo Weinhold
247fc8967f1SIngo Weinhold	# determine architecture from machine triple
248c0e8cc1aSIngo Weinhold	case $gccMachine in
249c0e8cc1aSIngo Weinhold		arm-*)		targetCpu=arm;;
250c0e8cc1aSIngo Weinhold		i?86-*)		targetCpu=x86;;
251c0e8cc1aSIngo Weinhold		m68k-*)		targetCpu=m68k;;
252c0e8cc1aSIngo Weinhold		powerpc-*)	targetCpu=ppc;;
253c0e8cc1aSIngo Weinhold		x86_64-*)	targetCpu=x86_64;;
254fc8967f1SIngo Weinhold		*)
255c0e8cc1aSIngo Weinhold			echo "Unsupported gcc target machine: $gccMachine" >&2
256fc8967f1SIngo Weinhold			exit 1
257fc8967f1SIngo Weinhold			;;
258fc8967f1SIngo Weinhold	esac
259fc8967f1SIngo Weinhold
260c0e8cc1aSIngo Weinhold	local targetArch=$targetCpu
261fc8967f1SIngo Weinhold
262c0e8cc1aSIngo Weinhold	case $gccRawVersion in
2636cc8eecfSOliver Tappe		2.9*)
2645b0f7b1bSOliver Tappe			# check for correct (most up-to-date) legacy compiler and complain
2655b0f7b1bSOliver Tappe			# if an older one is installed
266c0e8cc1aSIngo Weinhold			if [ $gccRawVersion != $haikuRequiredLegacyGCCVersion ]; then
2675b0f7b1bSOliver Tappe				echo "GCC version $haikuRequiredLegacyGCCVersion is required!";
2685b0f7b1bSOliver Tappe				echo "Please download it from www.haiku-os.org...";
2695b0f7b1bSOliver Tappe				exit 1;
2705b0f7b1bSOliver Tappe			fi
271aaeadfcbSAlex Smith
272c0e8cc1aSIngo Weinhold			targetArch=x86_gcc2
2735b0f7b1bSOliver Tappe			;;
2748b5934c9SIngo Weinhold	esac
27565ad1ba3SAlex Smith
276c0e8cc1aSIngo Weinhold	local bootLibgcc
277c0e8cc1aSIngo Weinhold	local bootLibSupCxx
27866a7f29fSJérôme Duval	local bootCxxHeaders
279c0e8cc1aSIngo Weinhold	case $gccMachine in
2804591ebc9SAlex Smith		x86_64-*)
28166a7f29fSJérôme Duval			# Boot loader is 32-bit, need the 32-bit libs and c++ config
28211ae3c5fSOliver Tappe			bootLibgcc=`$gcc -m32 -print-file-name=libgcc.a`
283c0e8cc1aSIngo Weinhold			bootLibSupCxx=`$gcc -m32 -print-file-name=libsupc++.a`
28466a7f29fSJérôme Duval
28566a7f29fSJérôme Duval			local headersBase=$gccdir/../../../..
28666a7f29fSJérôme Duval			local headers=$headersBase/$gccMachine/include/c++/$gccRawVersion
28766a7f29fSJérôme Duval			if [ ! -d $headers ]; then
28866a7f29fSJérôme Duval				headers=$headersBase/include/c++/$gccRawVersion
28966a7f29fSJérôme Duval			fi
29066a7f29fSJérôme Duval			bootCxxHeaders="$headers/$gccMachine/32"
2914591ebc9SAlex Smith			;;
292338b8dc3SIngo Weinhold	esac
293c0e8cc1aSIngo Weinhold
294c0e8cc1aSIngo Weinhold	# determine whether graphite loop optimization should/can be used
295c0e8cc1aSIngo Weinhold	local useGraphite=`get_variable HAIKU_USE_GCC_GRAPHITE_$targetCpu`
296c0e8cc1aSIngo Weinhold	if [ -z "$useGraphite" ]; then
297c0e8cc1aSIngo Weinhold		useGraphite=$useGccGraphiteDefault
298c0e8cc1aSIngo Weinhold	fi
299c0e8cc1aSIngo Weinhold
300c0e8cc1aSIngo Weinhold	if [ "$useGraphite" != 0 ]; then
301c0e8cc1aSIngo Weinhold		UNUSED=`echo "int main() {}" | $gcc -xc -c -floop-block - 2>&1`
302c0e8cc1aSIngo Weinhold		if [ $? != 0 ]; then
303c0e8cc1aSIngo Weinhold			echo "GCC Graphite loop optimizations cannot be used on $targetArch"
304c0e8cc1aSIngo Weinhold			useGraphite=0
305c0e8cc1aSIngo Weinhold		fi
306c0e8cc1aSIngo Weinhold	fi
307c0e8cc1aSIngo Weinhold
308c0e8cc1aSIngo Weinhold	set_variable HAIKU_CPU_$targetArch $targetCpu
309c0e8cc1aSIngo Weinhold
310c0e8cc1aSIngo Weinhold	get_build_tool_path CC_$targetArch "$gcc"
311a7bddff1SJonathan Schleifer	set_variable HAIKU_CC_IS_CLANG_$targetArch $useClang
312c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_RAW_VERSION_$targetArch $gccRawVersion
313c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_MACHINE_$targetArch $gccMachine
314c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_LIB_DIR_$targetArch $gccdir
31566a7f29fSJérôme Duval	set_variable HAIKU_BOOT_CXX_HEADERS_DIR_$targetArch "$bootCxxHeaders"
31611ae3c5fSOliver Tappe	set_variable HAIKU_BOOT_LIBSUPCXX_$targetArch "$bootLibSupCxx"
31711ae3c5fSOliver Tappe	set_variable HAIKU_BOOT_LIBGCC_$targetArch $bootLibgcc
318c0e8cc1aSIngo Weinhold	set_variable HAIKU_USE_GCC_GRAPHITE_$targetArch $useGraphite
319c0e8cc1aSIngo Weinhold
320c0e8cc1aSIngo Weinhold	standard_gcc_settings_targetArch=$targetArch
321c0e8cc1aSIngo Weinhold}
322c0e8cc1aSIngo Weinhold
323c0e8cc1aSIngo Weinhold# set_variable
324c0e8cc1aSIngo Weinhold#
325c0e8cc1aSIngo Weinhold# Set the value of a variable.
326c0e8cc1aSIngo Weinhold#
327c0e8cc1aSIngo Weinholdset_variable()
328c0e8cc1aSIngo Weinhold{
329c0e8cc1aSIngo Weinhold	eval "$1=\"$2\""
330c0e8cc1aSIngo Weinhold}
331c0e8cc1aSIngo Weinhold
332c0e8cc1aSIngo Weinhold# get_variable
333c0e8cc1aSIngo Weinhold#
334c0e8cc1aSIngo Weinhold# Echo the value of a variable.
335c0e8cc1aSIngo Weinhold#
336c0e8cc1aSIngo Weinholdget_variable()
337c0e8cc1aSIngo Weinhold{
338c0e8cc1aSIngo Weinhold	eval "echo \${$1}"
33909c5682dSIngo Weinhold}
34009c5682dSIngo Weinhold
341338b8dc3SIngo Weinhold# set_default_value
342338b8dc3SIngo Weinhold#
343338b8dc3SIngo Weinhold# Set the value for a variable, if no value is set yet.
344338b8dc3SIngo Weinhold#
345338b8dc3SIngo Weinholdset_default_value()
346338b8dc3SIngo Weinhold{
3470838a930SJérôme Duval	eval "$1=\${$1-$2}"
348338b8dc3SIngo Weinhold}
349338b8dc3SIngo Weinhold
350338b8dc3SIngo Weinhold# get_build_tool_path
351338b8dc3SIngo Weinhold#
352338b8dc3SIngo Weinhold# Gets a usable absolute path of a build tool.
353338b8dc3SIngo Weinhold#
354338b8dc3SIngo Weinholdget_build_tool_path()
355338b8dc3SIngo Weinhold{
356338b8dc3SIngo Weinhold	local var="HAIKU_$1"
357a7bddff1SJonathan Schleifer	local cmd=$2
358a7bddff1SJonathan Schleifer	local path=${2%% *}
359338b8dc3SIngo Weinhold
360338b8dc3SIngo Weinhold	if [ -f "$path" ]; then
361338b8dc3SIngo Weinhold		# get absolute path
362a559f87aSFrançois Revol		local oldPwd="`pwd`"
363a559f87aSFrançois Revol		cd "`dirname "$path"`"
364a559f87aSFrançois Revol		path="`pwd`/`basename "$path"`"
365338b8dc3SIngo Weinhold		cd $oldPwd
366338b8dc3SIngo Weinhold	else
3677fe2e06cSMatt Madia		which "$path" > /dev/null 2>&1 || {
368338b8dc3SIngo Weinhold			echo "Build tool \"$path\" not found." >&2
369338b8dc3SIngo Weinhold			exit 1
370338b8dc3SIngo Weinhold		}
371338b8dc3SIngo Weinhold	fi
372338b8dc3SIngo Weinhold
373a7bddff1SJonathan Schleifer	eval "$var=\"$path ${cmd#${2%% *}}\""
374338b8dc3SIngo Weinhold}
375338b8dc3SIngo Weinhold
376483b28e4SIngo Weinholdis_in_list()
377483b28e4SIngo Weinhold{
378483b28e4SIngo Weinhold	local element
379483b28e4SIngo Weinhold	for element in $2; do
380483b28e4SIngo Weinhold		if [ "$1" = "$element" ]; then
381483b28e4SIngo Weinhold			return 0
382483b28e4SIngo Weinhold		fi
383483b28e4SIngo Weinhold	done
384483b28e4SIngo Weinhold	return 1
385483b28e4SIngo Weinhold}
386483b28e4SIngo Weinhold
3877f9beaf1SOliver Tappe# check for --help or -h and show usage immediately
3887f9beaf1SOliver Tappeif [ "$1" = "--help" ] || [ "$1" = "-h" ]; then
3898b420c2fSOliver Tappe	usage; exit 0;
3908b420c2fSOliver Tappefi
3918b420c2fSOliver Tappe
3928b420c2fSOliver Tappe
393338b8dc3SIngo Weinhold# get cwd and the source directory
394338b8dc3SIngo WeinholdcurrentDir=`pwd`
3956e7c6fe5SIngo Weinholdcd `dirname "$0"`
396338b8dc3SIngo WeinholdsourceDir=`pwd`
3976e7c6fe5SIngo Weinholdcd "$currentDir"
398338b8dc3SIngo Weinhold
39955d267a4SFrançois Revol# backup the passed arguments
40055d267a4SFrançois RevolconfigureArgs="$@"
40155d267a4SFrançois Revol
4027c4641d0SOliver Tappe# internal default parameter values
403022fa244SIngo Weinhold#
40452a38012Sejakowatzplatform=`uname`
4055abd9a46SIngo WeinholdplatformMachine=`uname  -m`
406c0e8cc1aSIngo WeinholdtargetArchs=
407338b8dc3SIngo WeinholdbuildCrossTools=
40829ef597dSIngo WeinholdbuildCrossToolsScript="$sourceDir/build/scripts/build_cross_tools"
40960d8d8fcSIngo WeinholdbuildCrossToolsJobs=
410c2b76f7fSJonathan SchleiferuseClang=0
411c0e8cc1aSIngo WeinholduseGccGraphiteDefault=0
412c0e8cc1aSIngo WeinholdunknownArchIndex=1
413483b28e4SIngo WeinholdhaikuTargetArchs=
4144da6cf84SFrançois RevolgdbSources=
4157c4641d0SOliver Tappe
41663701e7dSOliver Tappeif [ -z "$CC" ]; then
41763701e7dSOliver Tappe	CC=gcc
41863701e7dSOliver Tappefi
41963701e7dSOliver Tappe
4207c4641d0SOliver Tappe# exported (BuildSetup) default parameter values
4217c4641d0SOliver Tappe#
42263701e7dSOliver TappeHOST_GCC_RAW_VERSION=`$CC -dumpversion`
42363701e7dSOliver TappeHOST_GCC_MACHINE=`$CC -dumpmachine`
4247c4641d0SOliver TappeHAIKU_INCLUDE_GPL_ADDONS=0
4257c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE=0
42676fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES=0
4277c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY=0
4287c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER=0
4297c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY=default
4307c4641d0SOliver TappeTARGET_PLATFORM=haiku
4317c4641d0SOliver TappeHAIKU_USE_GCC_PIPE=0
4327986925fSIngo WeinholdHAIKU_HOST_USE_32BIT=0
4337986925fSIngo WeinholdHAIKU_HOST_USE_XATTR=0
434bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF=0
4352ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY=0
436f04f7042SNiels Sascha ReedijkHOST_EXTENDED_REGEX_SED="sed -r"
43763701e7dSOliver TappeHOST_GCC_LD=`$CC -print-prog-name=ld`
43863701e7dSOliver TappeHOST_GCC_OBJCOPY=`$CC -print-prog-name=objcopy`
4392a5d0aafSIngo WeinholdHOST_SHA256=
440e173a1ecSIngo WeinholdHOST_HAIKU_PORTER=
441e173a1ecSIngo WeinholdHAIKU_PORTS=
442e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS=
443c9dd05ffSJonathan SchleiferHAIKU_IS_BOOTSTRAP=0
444e70c4c64SPulkoMandyHAIKU_BOOT_BOARD=
445aa2e5ecaSOliver TappeHAIKU_NO_DOWNLOADS=0
4462a5d0aafSIngo Weinhold
447c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS=
448c0e8cc1aSIngo Weinhold
449a04a520bSJonathan Schleiferset_default_value HAIKU_NASM		nasm
450c0e8cc1aSIngo Weinhold
4513942ca0dSIngo Weinholdif sha256sum < /dev/null > /dev/null 2>&1; then
4522a5d0aafSIngo Weinhold	HOST_SHA256=sha256sum
4533942ca0dSIngo Weinholdelif sha256 < /dev/null > /dev/null 2>&1; then
4542a5d0aafSIngo Weinhold	HOST_SHA256="sha256 -q"
455b5a871b1SNiels Sascha Reedijkelif shasum < /dev/null > /dev/null 2>&1; then
456b5a871b1SNiels Sascha Reedijk	HOST_SHA256="shasum -a 256"
4572a5d0aafSIngo Weinholdelse
4582a5d0aafSIngo Weinhold	echo "Error: Neither sha256sum nor sha256 seem to be available!" >&2
4592a5d0aafSIngo Weinhold	exit 1
4602a5d0aafSIngo Weinholdfi
461338b8dc3SIngo Weinhold
462*84edb1a1SAxel DörflerhaikuRequiredLegacyGCCVersion="2.95.3-haiku-2017_07_20"
463a559f87aSFrançois Revolexport haikuRequiredLegacyGCCVersion
464af4bf973SOliver Tappe	# version of legacy gcc required to build haiku
465483b28e4SIngo WeinholdsupportedTargetArchs="
466483b28e4SIngo Weinhold	arm
467483b28e4SIngo Weinhold	m68k
468483b28e4SIngo Weinhold	ppc
469483b28e4SIngo Weinhold	x86
470483b28e4SIngo Weinhold	x86_64
471483b28e4SIngo Weinhold	x86_gcc2
472483b28e4SIngo Weinhold	"
473af4bf973SOliver Tappe
4747c4641d0SOliver Tappe# determine output directory
4757c4641d0SOliver Tappeif [ "$currentDir" = "$sourceDir" ]; then
4767c4641d0SOliver Tappe	outputDir=$currentDir/generated
4777c4641d0SOliver Tappeelse
4787c4641d0SOliver Tappe	outputDir=$currentDir
4797c4641d0SOliver Tappefi
4807c4641d0SOliver TappebuildOutputDir="$outputDir/build"
4817c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR="$outputDir/attributes"
4827c4641d0SOliver TappebuildConfigFile="$buildOutputDir/BuildConfig"
4837c4641d0SOliver Tappe
4847c4641d0SOliver Tappe# check for update request
4857c4641d0SOliver Tappeif [ "$1" = "--update" ]; then
4867c4641d0SOliver Tappe	if ! [ -e "$buildConfigFile" ]; then
4877c4641d0SOliver Tappe		echo $0 --update: \'$buildConfigFile\' not found - updating not possible.
4887c4641d0SOliver Tappe		exit 1
4897c4641d0SOliver Tappe	fi
4907c4641d0SOliver Tappe	if ! type perl >/dev/null 2>&1; then
4917c4641d0SOliver Tappe		echo $0 --update: \'perl\' not found - updating not possible.
4927c4641d0SOliver Tappe		exit 1
4937c4641d0SOliver Tappe	fi
4947c4641d0SOliver Tappe	# convert BuildConfig from jam format to shell format and evaluate it
4957c4641d0SOliver Tappe	shellConfigFile="${buildConfigFile}.shell"
4967c4641d0SOliver Tappe	perl "$sourceDir/build/scripts/convert_build_config_to_shell_format.pl" \
4977c4641d0SOliver Tappe		<"$buildConfigFile" >"$shellConfigFile"
4987c4641d0SOliver Tappe	. "$shellConfigFile"
4997c4641d0SOliver Tappe	rm "$shellConfigFile"
5007c4641d0SOliver Tappe	shift
5017c4641d0SOliver Tappefi
5027c4641d0SOliver Tappe
503022fa244SIngo Weinhold# parse parameters
504022fa244SIngo Weinhold#
50520ab75e6SIngo Weinholdwhile [ $# -gt 0 ] ; do
506022fa244SIngo Weinhold	case "$1" in
507e173a1ecSIngo Weinhold		--bootstrap)
508e173a1ecSIngo Weinhold			assertparams "$1" 3 $#
509e173a1ecSIngo Weinhold			HOST_HAIKU_PORTER="`absolute_path $2`"
510e173a1ecSIngo Weinhold			HAIKU_PORTS_CROSS="`absolute_path $3`"
511e173a1ecSIngo Weinhold			HAIKU_PORTS="`absolute_path $4`"
512c9dd05ffSJonathan Schleifer			HAIKU_IS_BOOTSTRAP=1
513c9dd05ffSJonathan Schleifer			HAIKU_NO_DOWNLOADS=1
514502882dbSJessica Hamilton			check_file_exists "$HOST_HAIKU_PORTER" || (
515502882dbSJessica Hamilton				echo "Invalid path to haikuporter: $HOST_HAIKU_PORTER" >&2
51639d444a3SArvind S Raj				exit 1
51739d444a3SArvind S Raj			)
51839d444a3SArvind S Raj			check_dir_exists "$HAIKU_PORTS" || (
51939d444a3SArvind S Raj				echo "Non-existent directory $HAIKU_PORTS" >&2
52039d444a3SArvind S Raj				exit 1
52139d444a3SArvind S Raj			)
52239d444a3SArvind S Raj			check_dir_exists "$HAIKU_PORTS_CROSS" || (
52339d444a3SArvind S Raj				echo "Non-existent directory $HAIKU_PORTS_CROSS" >&2
52439d444a3SArvind S Raj				exit 1
52539d444a3SArvind S Raj			)
526e173a1ecSIngo Weinhold			shift 4
527e173a1ecSIngo Weinhold			;;
528c0e8cc1aSIngo Weinhold		--build-cross-tools)
529c0e8cc1aSIngo Weinhold			if [ -z "$buildCrossTools" ]; then
5309b0dd528SIngo Weinhold				assertparams "$1" 2 $#
531c0e8cc1aSIngo Weinhold				targetArch=$2
5329b0dd528SIngo Weinhold				buildCrossTools=$3
5339b0dd528SIngo Weinhold				shift 3
534c0e8cc1aSIngo Weinhold			else
535c0e8cc1aSIngo Weinhold				assertparam "$1" $#
536c0e8cc1aSIngo Weinhold				targetArch=$2
537c0e8cc1aSIngo Weinhold				shift 2
538c0e8cc1aSIngo Weinhold			fi
539c0e8cc1aSIngo Weinhold			case "$targetArch" in
540c0e8cc1aSIngo Weinhold				x86_gcc2)	targetMachine=i586-pc-haiku;;
541c0e8cc1aSIngo Weinhold				x86)		targetMachine=i586-pc-haiku;;
542c0e8cc1aSIngo Weinhold				x86_64)		targetMachine=x86_64-unknown-haiku;;
543c0e8cc1aSIngo Weinhold				ppc)		targetMachine=powerpc-apple-haiku;;
544c0e8cc1aSIngo Weinhold				m68k)		targetMachine=m68k-unknown-haiku;;
545c0e8cc1aSIngo Weinhold				arm)		targetMachine=arm-unknown-haiku;;
546c0e8cc1aSIngo Weinhold				*)
547c0e8cc1aSIngo Weinhold					echo "Unsupported target architecture: $2" >&2
548c0e8cc1aSIngo Weinhold					exit 1
549c0e8cc1aSIngo Weinhold					;;
550c0e8cc1aSIngo Weinhold			esac
551c0e8cc1aSIngo Weinhold			set_variable buildCrossToolsMachine_$targetArch $targetMachine
552c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
553c0e8cc1aSIngo Weinhold			HAIKU_PACKAGING_ARCHS=
5549b0dd528SIngo Weinhold			;;
5559b0dd528SIngo Weinhold		--cross-tools-prefix)
5569b0dd528SIngo Weinhold			assertparam "$1" $#
557c0e8cc1aSIngo Weinhold			targetArch=unknown${unknownArchIndex}
558c0e8cc1aSIngo Weinhold			set_variable crossToolsPrefix_$targetArch "$2"
559c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
560c0e8cc1aSIngo Weinhold			HAIKU_PACKAGING_ARCHS=
561d68208faSMatt Madia			unknownArchIndex=$(($unknownArchIndex + 1))
5629b0dd528SIngo Weinhold			shift 2
5639b0dd528SIngo Weinhold			;;
564a66c32ddSIngo Weinhold		--distro-compatibility)
5659b0dd528SIngo Weinhold			assertparam "$1" $#
5667c4641d0SOliver Tappe			HAIKU_DISTRO_COMPATIBILITY=$2
5677c4641d0SOliver Tappe			case "$HAIKU_DISTRO_COMPATIBILITY" in
568a66c32ddSIngo Weinhold				official)	;;
569a66c32ddSIngo Weinhold				compatible)	;;
570a66c32ddSIngo Weinhold				default)	;;
571a66c32ddSIngo Weinhold				*)			echo "Invalid distro compatibility" \
5727c4641d0SOliver Tappe								"level: $HAIKU_DISTRO_COMPATIBILITY"
573a66c32ddSIngo Weinhold							exit 1;;
574a66c32ddSIngo Weinhold			esac
5759b0dd528SIngo Weinhold			shift 2
5769b0dd528SIngo Weinhold			;;
5777c4641d0SOliver Tappe		--enable-multiuser)	HAIKU_ENABLE_MULTIUSER=1; shift 1;;
5782ebcd86dSIngo Weinhold		--host-only)	HAIKU_HOST_BUILD_ONLY=1; shift 1;;
5797c4641d0SOliver Tappe		--include-gpl-addons)	HAIKU_INCLUDE_GPL_ADDONS=1; shift 1;;
5807c4641d0SOliver Tappe		--include-patented-code)	HAIKU_INCLUDE_PATENTED_CODE=1; shift 1;;
58176fa0be3SIngo Weinhold		--include-sources)	HAIKU_INCLUDE_SOURCES=1; shift 1;;
5827c4641d0SOliver Tappe		--include-3rdparty)	HAIKU_INCLUDE_3RDPARTY=1; shift 1;;
58360d8d8fcSIngo Weinhold        -j*)				buildCrossToolsJobs="$1"; shift 1;;
584aa2e5ecaSOliver Tappe		--no-downloads)	HAIKU_NO_DOWNLOADS=1; shift 1;;
5857c4641d0SOliver Tappe		--target=*)     TARGET_PLATFORM=`echo $1 | cut -d'=' -f2-`; shift 1;;
586483b28e4SIngo Weinhold		--target-arch)
587483b28e4SIngo Weinhold			assertparam "$1" $#
588483b28e4SIngo Weinhold			targetArch=$2
589483b28e4SIngo Weinhold			shift 2
590483b28e4SIngo Weinhold			if [ ! "$platform" = Haiku ]; then
591483b28e4SIngo Weinhold				echo "--target-arch can only be specified on Haiku." >&2
592483b28e4SIngo Weinhold				exit 1
593483b28e4SIngo Weinhold			fi
594483b28e4SIngo Weinhold			is_in_list "$targetArch" "$supportedTargetArchs" || (
595483b28e4SIngo Weinhold				echo "Unsupported target architecture: \"$targetArch\"" >&2
596483b28e4SIngo Weinhold				exit 1
597483b28e4SIngo Weinhold			)
598483b28e4SIngo Weinhold			haikuTargetArchs="$haikuTargetArchs $targetArch"
599483b28e4SIngo Weinhold			;;
600c2b76f7fSJonathan Schleifer		--use-clang) useClang=1; shift 1;;
6017c4641d0SOliver Tappe		--use-gcc-pipe)	HAIKU_USE_GCC_PIPE=1; shift 1;;
602c0e8cc1aSIngo Weinhold		--use-gcc-graphite)	useGccGraphiteDefault=1; shift 1;;
6037986925fSIngo Weinhold		--use-32bit)	HAIKU_HOST_USE_32BIT=1; shift 1;;
6047986925fSIngo Weinhold		--use-xattr)	HAIKU_HOST_USE_XATTR=1; shift 1;;
605bc96e8f3SIngo Weinhold		--use-xattr-ref)	HAIKU_HOST_USE_XATTR_REF=1; shift 1;;
6064da6cf84SFrançois Revol		--with-gdb)	gdbSources=$2; shift 2;;
607022fa244SIngo Weinhold		*)				echo Invalid argument: \`$1\'; exit 1;;
608022fa244SIngo Weinhold	esac
609022fa244SIngo Weinholddone
610022fa244SIngo Weinhold
6110df3cc9cSIngo Weinhold# detect the build platform
612338b8dc3SIngo Weinholdcase "${platform}" in
6137c4641d0SOliver Tappe	Darwin)	HOST_PLATFORM=darwin ;;
6147c4641d0SOliver Tappe	FreeBSD)	HOST_PLATFORM=freebsd
6157986925fSIngo Weinhold				if [ "$HAIKU_HOST_USE_32BIT" = 1 ] ; then
6165abd9a46SIngo Weinhold					echo Unsupported platform: FreeBSD ${platformMachine}
617308c212cSIngo Weinhold					exit 1
618308c212cSIngo Weinhold				fi	;;
6197c4641d0SOliver Tappe	Haiku)	HOST_PLATFORM=haiku_host ;;
6207c4641d0SOliver Tappe	Linux)	HOST_PLATFORM=linux ;;
6217c4641d0SOliver Tappe	OpenBSD) HOST_PLATFORM=openbsd ;;
6227c4641d0SOliver Tappe	SunOS)	HOST_PLATFORM=sunos ;;
6237c4641d0SOliver Tappe	CYGWIN_NT-*) HOST_PLATFORM=cygwin ;;
624338b8dc3SIngo Weinhold	*)		echo Unsupported platform: ${platform}
6254cbe4925SAxel Dörfler			exit 1 ;;
6264cbe4925SAxel Dörfleresac
62752a38012Sejakowatz
6280962132cSAlex Smith# check for case-sensitive filesystem
6290962132cSAlex Smithmkdir haikuCaseTest 2>/dev/null
6300962132cSAlex Smithmkdir haikucasetest 2>/dev/null
6310962132cSAlex SmithcaseInsensitive=$?
63297f5a0bdSAlex Smithrmdir haikuCaseTest haikucasetest 2>/dev/null
6330962132cSAlex Smithif [ $caseInsensitive != 0 ]; then
6343ecc5287SMichael Lotz	echo "You need a case-sensitive file-system to build Haiku."
6350962132cSAlex Smith	if [ $HOST_PLATFORM = "darwin" ]; then
6367a05e252SJohn Scipione		echo "You can create a case-sensitive disk image using Disk Utility."
6373ecc5287SMichael Lotz	fi
6380962132cSAlex Smith	exit 1
6393ecc5287SMichael Lotzfi
6403ecc5287SMichael Lotz
641f04f7042SNiels Sascha Reedijk# determine how to invoke sed with extended regexp support for non-GNU sed
642f04f7042SNiels Sascha Reedijkif [ $HOST_PLATFORM = "darwin" ]; then
643f04f7042SNiels Sascha Reedijk	HOST_EXTENDED_REGEX_SED="sed -E"
644f04f7042SNiels Sascha Reedijkfi
645f04f7042SNiels Sascha Reedijk
646cb721c59SFrançois Revol# check if nasm can actually output ELF files
647cb721c59SFrançois Revol# (the stock version in OSX can't)
648cb721c59SFrançois Revol# XXX: should probably only test for x86* arch
6493e6c09cdSAdrien Destuguesif [ "$("$HAIKU_NASM" -hf | grep -c elf'[36][24] ')" -ne "2" ]; then
650cb721c59SFrançois Revol	echo "$HAIKU_NASM cannot generate ELF files. Please install a working version."
651cb721c59SFrançois Revol	if [ $HOST_PLATFORM = "darwin" ]; then
652cb721c59SFrançois Revol		echo "You can install it from Mac Ports."
653cb721c59SFrançois Revol		echo "Mac Ports is available at: http://www.macports.org/"
654cb721c59SFrançois Revol	fi
655cb721c59SFrançois Revol	exit 1
656cb721c59SFrançois Revolfi
657cb721c59SFrançois Revol
658338b8dc3SIngo Weinhold# create output directory
6596e7c6fe5SIngo Weinholdmkdir -p "$buildOutputDir" || exit 1
660338b8dc3SIngo Weinhold
6612ebcd86dSIngo Weinholdif [ "$HAIKU_HOST_BUILD_ONLY" = 1 ]; then
6622ebcd86dSIngo Weinhold	invalidCommand=$sourceDir/build/scripts/host_build_only
6632ebcd86dSIngo Weinhold	HAIKU_AR=$invalidCommand
6642ebcd86dSIngo Weinhold	HAIKU_CC=$invalidCommand
6652ebcd86dSIngo Weinhold	HAIKU_LD=$invalidCommand
6662ebcd86dSIngo Weinhold	HAIKU_OBJCOPY=$invalidCommand
6672ebcd86dSIngo Weinhold	HAIKU_RANLIB=$invalidCommand
6682ebcd86dSIngo Weinhold	HAIKU_ELFEDIT=$invalidCommand
669d6f80927SJonathan Schleifer	HAIKU_NASM=$invalidCommand
6702ebcd86dSIngo Weinhold	HAIKU_STRIP=$invalidCommand
6712ebcd86dSIngo Weinholdelse
672c0e8cc1aSIngo Weinhold	if [ -n "$HAIKU_PACKAGING_ARCHS" ]; then
673c0e8cc1aSIngo Weinhold		targetArchs="$HAIKU_PACKAGING_ARCHS"
674c0e8cc1aSIngo Weinhold	fi
675c0e8cc1aSIngo Weinhold	HAIKU_PACKAGING_ARCHS=
676c0e8cc1aSIngo Weinhold
677483b28e4SIngo Weinhold	# On Haiku determine target architectures and tools automatically.
678c0e8cc1aSIngo Weinhold	if [ -z "$targetArchs" ]; then
679483b28e4SIngo Weinhold		if [ $HOST_PLATFORM != haiku_host ]; then
680483b28e4SIngo Weinhold			echo "Please specify the build tools to use or build (via" \
681eaef83a9SJeroen Oortwijn				"--cross-tools-prefix or --build-cross-tools) or specify a" \
682483b28e4SIngo Weinhold				"host-only build (--host-only)." >&2
6837f9beaf1SOliver Tappe			echo "For more info, invoke $0 --help"
684483b28e4SIngo Weinhold			exit 1
685483b28e4SIngo Weinhold		fi
686483b28e4SIngo Weinhold
687483b28e4SIngo Weinhold		# determine primary architecture
688dda53eaeSIngo Weinhold		targetArch=`package list -i /system/packages/haiku-*.hpkg \
689483b28e4SIngo Weinhold			| sed '/^\s*architecture:/!d; s,^\s*architecture:\s*,,'`
690483b28e4SIngo Weinhold		is_in_list "$targetArch" "$supportedTargetArchs" || (
691483b28e4SIngo Weinhold			echo "Unsupported target architecture: \"$targetArch\"" >&2
692483b28e4SIngo Weinhold			exit 1
693483b28e4SIngo Weinhold		)
694c0e8cc1aSIngo Weinhold		targetArchs=$targetArch
695483b28e4SIngo Weinhold
696c0e8cc1aSIngo Weinhold		set_default_value HAIKU_AR_$targetArch			ar
697c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CC_$targetArch			gcc
698c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LD_$targetArch			ld
699c0e8cc1aSIngo Weinhold		set_default_value HAIKU_OBJCOPY_$targetArch		objcopy
700c0e8cc1aSIngo Weinhold		set_default_value HAIKU_RANLIB_$targetArch		ranlib
701c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ELFEDIT_$targetArch		elfedit
702c0e8cc1aSIngo Weinhold		set_default_value HAIKU_STRIP_$targetArch		strip
703483b28e4SIngo Weinhold
704483b28e4SIngo Weinhold		# determine secondary architectures
705483b28e4SIngo Weinhold		for targetArch in $supportedTargetArchs; do
70680262a91SMatt Madia			if [ -e /system/packages/haiku_$targetArch-*.hpkg ]; then
707483b28e4SIngo Weinhold				targetArchs="$targetArchs $targetArch"
708483b28e4SIngo Weinhold				set_default_value HAIKU_AR_$targetArch		ar-$targetArch
709483b28e4SIngo Weinhold				set_default_value HAIKU_CC_$targetArch		gcc-$targetArch
710483b28e4SIngo Weinhold				set_default_value HAIKU_LD_$targetArch		ld-$targetArch
711483b28e4SIngo Weinhold				set_default_value HAIKU_OBJCOPY_$targetArch	objcopy-$targetArch
712483b28e4SIngo Weinhold				set_default_value HAIKU_RANLIB_$targetArch	ranlib-$targetArch
713483b28e4SIngo Weinhold				set_default_value HAIKU_ELFEDIT_$targetArch	elfedit-$targetArch
714483b28e4SIngo Weinhold				set_default_value HAIKU_STRIP_$targetArch	strip-$targetArch
715483b28e4SIngo Weinhold			fi
716483b28e4SIngo Weinhold		done
717483b28e4SIngo Weinhold
718483b28e4SIngo Weinhold		# The target architectures might have been specified explicitly.
719483b28e4SIngo Weinhold		if [ -n "$haikuTargetArchs" ]; then
720483b28e4SIngo Weinhold			for targetArch in $haikuTargetArchs; do
721483b28e4SIngo Weinhold				is_in_list "$targetArch" "$targetArchs" || (
722483b28e4SIngo Weinhold					echo "Unsupported target architecture: \"$targetArch\"." \
723483b28e4SIngo Weinhold						"Only native architectures of the host platform can" \
724483b28e4SIngo Weinhold						"be specified." >&2
725483b28e4SIngo Weinhold					exit 1
726483b28e4SIngo Weinhold				)
727483b28e4SIngo Weinhold			done
728483b28e4SIngo Weinhold			targetArchs="$haikuTargetArchs"
729483b28e4SIngo Weinhold		fi
730c0e8cc1aSIngo Weinhold	fi
731c0e8cc1aSIngo Weinhold
73268ccc989SIngo Weinhold	isPrimaryArch=1
733c0e8cc1aSIngo Weinhold	for targetArch in $targetArchs; do
734c0e8cc1aSIngo Weinhold		# Note: targetArch is "unknown<n>" at this point, if a cross-tools
735c0e8cc1aSIngo Weinhold		# prefix was specified. The standard_gcc_settings call below will get
736c0e8cc1aSIngo Weinhold		# the actual architecture.
737c0e8cc1aSIngo Weinhold
738c0e8cc1aSIngo Weinhold		crossToolsPrefix=`get_variable crossToolsPrefix_$targetArch`
739c0e8cc1aSIngo Weinhold
740338b8dc3SIngo Weinhold		# build cross tools from sources
741c0e8cc1aSIngo Weinhold		if [ -n "$buildCrossTools" -a -z "$crossToolsPrefix" ]; then
742c0e8cc1aSIngo Weinhold			crossToolsDir="$outputDir/cross-tools-$targetArch"
743c0e8cc1aSIngo Weinhold			targetMachine=`get_variable buildCrossToolsMachine_$targetArch`
744c0e8cc1aSIngo Weinhold			script="$buildCrossToolsScript"
7458304ec7cSIngo Weinhold			scriptArgs=
746c0e8cc1aSIngo Weinhold			if [ $targetArch != x86_gcc2 ]; then
7478304ec7cSIngo Weinhold				script="${script}_gcc4"
7488304ec7cSIngo Weinhold				scriptArgs="$targetMachine"
7491e93288eSJérôme Duval				set_default_value HAIKU_USE_GCC_GRAPHITE_$targetArch	\
7501e93288eSJérôme Duval					$useGccGraphiteDefault
751c0e8cc1aSIngo Weinhold			fi
75268ccc989SIngo Weinhold			secondaryArch=
75368ccc989SIngo Weinhold			if [ -z "$isPrimaryArch" ]; then
75468ccc989SIngo Weinhold				secondaryArch=$targetArch
75568ccc989SIngo Weinhold			fi
75686de8c37SIngo Weinhold
75786de8c37SIngo Weinhold			case $HOST_PLATFORM in
75886de8c37SIngo Weinhold				freebsd|openbsd)	MAKE=gmake;;
75986de8c37SIngo Weinhold				*)					MAKE=make;;
76086de8c37SIngo Weinhold			esac
76186de8c37SIngo Weinhold
76286de8c37SIngo Weinhold			MAKE=$MAKE \
76368ccc989SIngo Weinhold			SECONDARY_ARCH=$secondaryArch \
764c0e8cc1aSIngo Weinhold			HAIKU_USE_GCC_GRAPHITE=`get_variable \
765c0e8cc1aSIngo Weinhold				HAIKU_USE_GCC_GRAPHITE_$targetArch` \
766b3ece905SJérôme Duval			HAIKU_USE_GCC_PIPE=$HAIKU_USE_GCC_PIPE \
7674da6cf84SFrançois Revol			HAIKU_USE_GDB="$gdbSources" \
7688304ec7cSIngo Weinhold			"$script" $scriptArgs "$sourceDir" "$buildCrossTools" \
7698304ec7cSIngo Weinhold				"$crossToolsDir" $buildCrossToolsJobs || exit 1
770c0e8cc1aSIngo Weinhold			crossToolsPrefix="$crossToolsDir/bin/${targetMachine}-"
771338b8dc3SIngo Weinhold		fi
772338b8dc3SIngo Weinhold
773c0e8cc1aSIngo Weinhold		# prepare gcc settings and get the actual target architecture
774a7bddff1SJonathan Schleifer		if [ $useClang = 1 ]; then
775a7bddff1SJonathan Schleifer			target=${crossToolsPrefix##*/}
776a7bddff1SJonathan Schleifer			target=${target%-}
777c6fb0e2cSJonathan Schleifer			gcc="clang -target ${target} -no-integrated-as"
778a7bddff1SJonathan Schleifer		else
779c0e8cc1aSIngo Weinhold			gcc="${crossToolsPrefix}gcc"
780a7bddff1SJonathan Schleifer		fi
781c0e8cc1aSIngo Weinhold		if [ -z "${crossToolsPrefix}" ]; then
782c0e8cc1aSIngo Weinhold			gcc=`get_variable HAIKU_CC_$targetArch`
783338b8dc3SIngo Weinhold		fi
784c0e8cc1aSIngo Weinhold		standard_gcc_settings "$gcc"
785c0e8cc1aSIngo Weinhold		targetArch=$standard_gcc_settings_targetArch
786338b8dc3SIngo Weinhold
787c0e8cc1aSIngo Weinhold		# set default values for flags
788c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CPPFLAGS_$targetArch	""
789c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CCFLAGS_$targetArch		""
790c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CXXFLAGS_$targetArch	""
791c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LDFLAGS_$targetArch		""
792c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ARFLAGS_$targetArch		cru
793c0e8cc1aSIngo Weinhold		set_default_value HAIKU_UNARFLAGS_$targetArch	x
794338b8dc3SIngo Weinhold
795c0e8cc1aSIngo Weinhold		# Override the cross tools variables, if the tools were built or a
796c0e8cc1aSIngo Weinhold		# prefix was specified.
797b7777272SAlex Smith		if [ -n "$crossToolsPrefix" ]; then
798c0e8cc1aSIngo Weinhold			get_build_tool_path AR_$targetArch ${crossToolsPrefix}ar
799c0e8cc1aSIngo Weinhold			get_build_tool_path LD_$targetArch ${crossToolsPrefix}ld
800c0e8cc1aSIngo Weinhold			get_build_tool_path OBJCOPY_$targetArch ${crossToolsPrefix}objcopy
801c0e8cc1aSIngo Weinhold			get_build_tool_path RANLIB_$targetArch ${crossToolsPrefix}ranlib
802c0e8cc1aSIngo Weinhold			get_build_tool_path STRIP_$targetArch ${crossToolsPrefix}strip
803c0e8cc1aSIngo Weinhold
804c0e8cc1aSIngo Weinhold			case `get_variable HAIKU_GCC_RAW_VERSION_$targetArch` in
805133e4131SJérôme Duval				4.*|5.*|6.*|7.*|8.*)
806c0e8cc1aSIngo Weinhold					get_build_tool_path ELFEDIT_$targetArch \
807c0e8cc1aSIngo Weinhold						${crossToolsPrefix}elfedit
808bd16f0ddSAlex Smith				;;
809bd16f0ddSAlex Smith			esac
81052a38012Sejakowatz		fi
81152a38012Sejakowatz
812ef57df3dSIngo Weinhold		# check whether the Haiku compiler really targets Haiku
813c0e8cc1aSIngo Weinhold		targetMachine=`get_variable HAIKU_GCC_MACHINE_$targetArch`
814c0e8cc1aSIngo Weinhold		case "$targetMachine" in
815eedc3d0bSIngo Weinhold			*-*-haiku)	;;
816c0e8cc1aSIngo Weinhold			*)
817c0e8cc1aSIngo Weinhold				echo The compiler specified as Haiku target compiler is not a \
818c0e8cc1aSIngo Weinhold				valid Haiku cross-compiler. Please see ReadMe.cross-compile. >&2
819eedc3d0bSIngo Weinhold				echo compiler: $HAIKU_CC
820c0e8cc1aSIngo Weinhold				echo compiler is configured for target: $targetMachine
821eedc3d0bSIngo Weinhold				exit 1 ;;
822eedc3d0bSIngo Weinhold		esac
823c0e8cc1aSIngo Weinhold
824c0e8cc1aSIngo Weinhold		HAIKU_PACKAGING_ARCHS="$HAIKU_PACKAGING_ARCHS $targetArch"
82568ccc989SIngo Weinhold		isPrimaryArch=
826c0e8cc1aSIngo Weinhold	done
8272ebcd86dSIngo Weinholdfi
828eedc3d0bSIngo Weinhold
82952a38012Sejakowatz# Generate BuildConfig
8307c4641d0SOliver Tappecat << EOF > "$buildConfigFile"
83152a38012Sejakowatz# BuildConfig
832ab2540c4SIngo Weinhold# Note: This file has been automatically generated by configure with the
833ab2540c4SIngo Weinhold# following arguments:
83455d267a4SFrançois Revol# ${configureArgs}
83552a38012Sejakowatz
8367c4641d0SOliver TappeTARGET_PLATFORM 			?= "${TARGET_PLATFORM}" ;
8377c4641d0SOliver TappeHOST_PLATFORM				?= "${HOST_PLATFORM}" ;
838338b8dc3SIngo Weinhold
8397c4641d0SOliver TappeHAIKU_INCLUDE_GPL_ADDONS			?= "${HAIKU_INCLUDE_GPL_ADDONS}" ;
8407c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE			?= "${HAIKU_INCLUDE_PATENTED_CODE}" ;
84176fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES				?= "${HAIKU_INCLUDE_SOURCES}" ;
8427c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY				?= "${HAIKU_INCLUDE_3RDPARTY}" ;
8437c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER				?= "${HAIKU_ENABLE_MULTIUSER}" ;
8447c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY			?= "${HAIKU_DISTRO_COMPATIBILITY}" ;
8457c4641d0SOliver TappeHAIKU_USE_GCC_PIPE					?= "${HAIKU_USE_GCC_PIPE}" ;
8467986925fSIngo WeinholdHAIKU_HOST_USE_32BIT				?= "${HAIKU_HOST_USE_32BIT}" ;
8477986925fSIngo WeinholdHAIKU_HOST_USE_XATTR				?= "${HAIKU_HOST_USE_XATTR}" ;
848bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF			?= "${HAIKU_HOST_USE_XATTR_REF}" ;
8492ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY				?= "${HAIKU_HOST_BUILD_ONLY}" ;
850eccc7665SIngo Weinhold
851c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS		?= ${HAIKU_PACKAGING_ARCHS} ;
85265ad1ba3SAlex Smith
853aa2e5ecaSOliver TappeHAIKU_NO_DOWNLOADS			?= "${HAIKU_NO_DOWNLOADS}" ;
854aa2e5ecaSOliver Tappe
8557c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR	?= ${HAIKU_BUILD_ATTRIBUTES_DIR} ;
856338b8dc3SIngo Weinhold
857d6f80927SJonathan SchleiferHAIKU_NASM					?= ${HAIKU_NASM} ;
858e70c4c64SPulkoMandyHAIKU_BOOT_BOARD			?= ${HAIKU_BOOT_BOARD} ;
859338b8dc3SIngo Weinhold
860f04f7042SNiels Sascha ReedijkHOST_EXTENDED_REGEX_SED		?= ${HOST_EXTENDED_REGEX_SED} ;
8617c4641d0SOliver TappeHOST_GCC_RAW_VERSION		?= ${HOST_GCC_RAW_VERSION} ;
8627c4641d0SOliver TappeHOST_GCC_MACHINE			?= ${HOST_GCC_MACHINE} ;
8637c4641d0SOliver TappeHOST_LD						?= ${HOST_GCC_LD} ;
8647c4641d0SOliver TappeHOST_OBJCOPY				?= ${HOST_GCC_OBJCOPY} ;
8652a5d0aafSIngo WeinholdHOST_SHA256					?= ${HOST_SHA256} ;
8668b5934c9SIngo Weinhold
867e173a1ecSIngo WeinholdHOST_HAIKU_PORTER			?= ${HOST_HAIKU_PORTER} ;
868e173a1ecSIngo WeinholdHAIKU_PORTS					?= ${HAIKU_PORTS} ;
869e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS			?= ${HAIKU_PORTS_CROSS} ;
870c9dd05ffSJonathan SchleiferHAIKU_IS_BOOTSTRAP			?= ${HAIKU_IS_BOOTSTRAP} ;
871e173a1ecSIngo Weinhold
872c4786ea6SlilloEOF
873c4786ea6Slillo
874c0e8cc1aSIngo Weinholdfor targetArch in $HAIKU_PACKAGING_ARCHS; do
875c0e8cc1aSIngo Weinhold	variables="
876c0e8cc1aSIngo Weinhold		HAIKU_GCC_RAW_VERSION		HAIKU_GCC_RAW_VERSION
877c0e8cc1aSIngo Weinhold		HAIKU_GCC_MACHINE			HAIKU_GCC_MACHINE
878c0e8cc1aSIngo Weinhold		HAIKU_GCC_LIB_DIR			HAIKU_GCC_LIB_DIR
879c0e8cc1aSIngo Weinhold		HAIKU_CPU					HAIKU_CPU
880c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBGCC			HAIKU_BOOT_LIBGCC
881c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBSUPC++		HAIKU_BOOT_LIBSUPCXX
882c0e8cc1aSIngo Weinhold		HAIKU_AR					HAIKU_AR
883c0e8cc1aSIngo Weinhold		HAIKU_CC					HAIKU_CC
884c2b76f7fSJonathan Schleifer		HAIKU_CC_IS_CLANG			HAIKU_CC_IS_CLANG
885c0e8cc1aSIngo Weinhold		HAIKU_LD					HAIKU_LD
886c0e8cc1aSIngo Weinhold		HAIKU_OBJCOPY				HAIKU_OBJCOPY
887c0e8cc1aSIngo Weinhold		HAIKU_RANLIB				HAIKU_RANLIB
888c0e8cc1aSIngo Weinhold		HAIKU_ELFEDIT				HAIKU_ELFEDIT
889c0e8cc1aSIngo Weinhold		HAIKU_STRIP					HAIKU_STRIP
890c0e8cc1aSIngo Weinhold		HAIKU_CPPFLAGS				HAIKU_CPPFLAGS
891c0e8cc1aSIngo Weinhold		HAIKU_CCFLAGS				HAIKU_CCFLAGS
892c0e8cc1aSIngo Weinhold		HAIKU_C++FLAGS				HAIKU_CXXFLAGS
893c0e8cc1aSIngo Weinhold		HAIKU_LDFLAGS				HAIKU_LDFLAGS
894c0e8cc1aSIngo Weinhold		HAIKU_ARFLAGS				HAIKU_ARFLAGS
895c0e8cc1aSIngo Weinhold		HAIKU_UNARFLAGS				HAIKU_UNARFLAGS
896c0e8cc1aSIngo Weinhold		HAIKU_USE_GCC_GRAPHITE		HAIKU_USE_GCC_GRAPHITE
897c0e8cc1aSIngo Weinhold		"
898c0e8cc1aSIngo Weinhold	set -- $variables
899c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
900c0e8cc1aSIngo Weinhold		value=`get_variable ${2}_$targetArch`
901c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= $value ;" >> "$buildConfigFile"
902c0e8cc1aSIngo Weinhold		shift 2
903c0e8cc1aSIngo Weinhold	done
904b1e5b60cSAxel Dörfler
905c0e8cc1aSIngo Weinhold	# For variables that may have long values, distribute them over multiple
906c0e8cc1aSIngo Weinhold	# lines so that jam doesn't hit the maximum line length.
907c0e8cc1aSIngo Weinhold	variables="
90866a7f29fSJérôme Duval		HAIKU_BOOT_C++_HEADERS_DIR	HAIKU_BOOT_CXX_HEADERS_DIR
909c0e8cc1aSIngo Weinhold		"
910c0e8cc1aSIngo Weinhold	set -- $variables
911c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
912c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= " >> "$buildConfigFile"
913c0e8cc1aSIngo Weinhold		get_variable ${2}_$targetArch | xargs -n 1 echo "   " \
914c0e8cc1aSIngo Weinhold			>> "$buildConfigFile"
915c0e8cc1aSIngo Weinhold		echo "    ;" >> "$buildConfigFile"
916c0e8cc1aSIngo Weinhold		shift 2
917c0e8cc1aSIngo Weinhold	done
918c0e8cc1aSIngo Weinholddone
919b1e5b60cSAxel Dörfler
920b1e5b60cSAxel Dörfler
9219b0dd528SIngo Weinhold# Generate a boot strap Jamfile in the output directory.
922338b8dc3SIngo Weinhold
923338b8dc3SIngo Weinholdcat << EOF > $outputDir/Jamfile
924338b8dc3SIngo Weinhold# automatically generated Jamfile
925338b8dc3SIngo Weinhold
926338b8dc3SIngo WeinholdHAIKU_TOP			= ${sourceDir} ;
927338b8dc3SIngo WeinholdHAIKU_OUTPUT_DIR	= ${outputDir} ;
928338b8dc3SIngo Weinhold
929338b8dc3SIngo Weinholdinclude [ FDirName \$(HAIKU_TOP) Jamfile ] ;
930338b8dc3SIngo Weinhold
931338b8dc3SIngo WeinholdEOF
932